"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_tags_1 = require("common-tags");
function setXMLHttpRequest(w) {
    // by grabbing the XMLHttpRequest from app's iframe
    // and putting it here - in the test iframe
    // we suddenly get spying and stubbing 😁
    window.XMLHttpRequest = w.XMLHttpRequest;
    return w;
}
function setAlert(w) {
    window.alert = w.alert;
    return w;
}
exports.mount = function (state, actions, view) {
    if (!actions) {
        // we always want to have an actions object so we
        // can attach _getState utility function
        actions = {};
    }
    var html = common_tags_1.stripIndent(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    <div id=\"app\"></div>\n    <script defer src=\"https://unpkg.com/hyperapp\"></script>\n  "], ["\n    <div id=\"app\"></div>\n    <script defer src=\"https://unpkg.com/hyperapp\"></script>\n  "])));
    var document = cy.state('document');
    document.write(html);
    document.close();
    // add a utility action to get the current state
    if (!actions._getState) {
        var _getState = function () { return function (state) { return state; }; };
        actions = Object.assign({}, actions, { _getState: _getState });
    }
    cy
        .window({ log: false })
        .then(setXMLHttpRequest)
        .then(setAlert)
        .its('hyperapp.app')
        .then(function (app) {
        var el = document.getElementById('app');
        var main = app(state, actions, view, el);
        // wrap every hyper action with `cy.then` to
        // make sure it goes through the Cypress command queue
        // allows things like the example below to just work
        //   Cypress.main.setText('foo')
        //   cy.contains('foo')
        //   Cypress.main.setText('bar')
        //   cy.contains('bar')
        Cypress.main = {};
        Object.keys(main).forEach(function (name) {
            var action = main[name];
            Cypress.main[name] = function queueAction() {
                // should we log arguments?
                cy.log("action: " + name);
                return cy.then(function () { return action.apply(null, arguments); });
            };
        });
        return Cypress.main;
    });
    cy.get('#app', { log: false }).should('be.visible');
};
var templateObject_1;
